%define mit_ver 0.9.11a

Summary: Module utilities
Name: modutils
Version: 2.4.21
Release: 18
Serial: 2002120901
Copyright: GPL
Group: Utilities/System
Source: modutils-%{version}.tar.gz
Source1: module-init-tools-%{mit_ver}.tar.gz
ExclusiveOS: Linux
BuildRoot: /var/tmp/modutils-%{version}-%{release}-root

%description
The Linux kernel allows new kernel pieces to be loaded and old ones to
be unloaded while the kernel continues to run. These loadable pieces
are called modules, and can include device drivers and filesystems among
other things. This package includes program to load and unload programs
both automatically and manually.

This set does not include 'request-route' script nor kerneld (still
present in sources).  It is compiled without support for 2.0 and early
2.1 kernels, see INSTALL if you want modutils to run on old kernels.
It includes insmod.static for mkinitrd.

%prep
%setup
gunzip -c %{SOURCE1} | tar xf -
(cd module-init-tools-%{mit_ver}
)

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --enable-insmod-static --prefix=/ --mandir=%{_mandir}
make dep all
cd module-init-tools-%{mit_ver}
%configure
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man2
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man5
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man8
make install prefix=$RPM_BUILD_ROOT/usr exec_prefix=$RPM_BUILD_ROOT \
	     mandir=$RPM_BUILD_ROOT/%{_mandir}
# kerneld is not compiled by default, it is obsolete for kernel >= 2.1.91.
# (cd kerneld;
# make install-scripts prefix=$RPM_BUILD_ROOT/usr exec_prefix=$RPM_BUILD_ROOT
# )
# security hole, works poorly anyway
rm -f $RPM_BUILD_ROOT/sbin/request-route

# Move the old ones out the way.
for i in insmod insmod.static depmod; do
	mv $RPM_BUILD_ROOT/sbin/$i $RPM_BUILD_ROOT/sbin/$i.old
done
# These are symlinks, be careful.
for i in rmmod modprobe lsmod; do
	rm $RPM_BUILD_ROOT/sbin/$i
	ln -sf insmod.old $RPM_BUILD_ROOT/sbin/$i.old
done
# These don't have replacements, just move symlinks.
for i in kallsyms ksyms; do
	rm $RPM_BUILD_ROOT/sbin/$i
	ln -sf insmod.old $RPM_BUILD_ROOT/sbin/$i
done

# Move the man pages to xxx.old.
for i in depmod insmod lsmod modprobe rmmod; do
	mv $RPM_BUILD_ROOT/%{_mandir}/man8/$i.8 $RPM_BUILD_ROOT/%{_mandir}/man8/$i.old.8
done

(cd module-init-tools-%{mit_ver}
 cp generate-modprobe.conf insmod insmod.static rmmod modprobe lsmod depmod $RPM_BUILD_ROOT/sbin
 cp depmod.8 insmod.8 lsmod.8 modprobe.8 rmmod.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
 cp modprobe.conf.5 modules.dep.5 $RPM_BUILD_ROOT/%{_mandir}/man5/
)

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root)/sbin/generate-modprobe.conf
%attr(755,root,root)/sbin/depmod
%attr(755,root,root)/sbin/depmod.old
%attr(755,root,root)/sbin/genksyms
%attr(755,root,root)/sbin/insmod
%attr(755,root,root)/sbin/insmod.old
%attr(755,root,root)/sbin/insmod.static
%attr(755,root,root)/sbin/insmod.static.old
#%attr(755,root,root)/sbin/kerneld
%attr(755,root,root)/sbin/ksyms
%attr(755,root,root)/sbin/lsmod
%attr(755,root,root)/sbin/lsmod.old
%attr(755,root,root)/sbin/modinfo
%attr(755,root,root)/sbin/modprobe
%attr(755,root,root)/sbin/modprobe.old
%attr(755,root,root)/sbin/rmmod
%attr(755,root,root)/sbin/rmmod.old
%attr(755,root,root)/sbin/kallsyms
%attr(755,root,root)/sbin/insmod_ksymoops_clean
%attr(755,root,root)/sbin/kernelversion
%attr(644,root,root)%{_mandir}/man1/kernelversion.1*
%attr(644,root,root)%{_mandir}/man2/create_module.2*
%attr(644,root,root)%{_mandir}/man2/delete_module.2*
%attr(644,root,root)%{_mandir}/man2/get_kernel_syms.2*
%attr(644,root,root)%{_mandir}/man2/init_module.2*
%attr(644,root,root)%{_mandir}/man2/query_module.2*
%attr(644,root,root)%{_mandir}/man5/modules.conf.5*
%attr(644,root,root)%{_mandir}/man8/depmod.old.8*
%attr(644,root,root)%{_mandir}/man8/genksyms.8*
%attr(644,root,root)%{_mandir}/man8/insmod.old.8*
#%attr(644,root,root)%{_mandir}/man8/kdstat.8*
#%attr(644,root,root)%{_mandir}/man8/kerneld.8*
%attr(644,root,root)%{_mandir}/man8/ksyms.8*
%attr(644,root,root)%{_mandir}/man8/lsmod.old.8*
%attr(644,root,root)%{_mandir}/man8/modinfo.8*
%attr(644,root,root)%{_mandir}/man8/modprobe.old.8*
%attr(644,root,root)%{_mandir}/man8/rmmod.old.8*
%attr(644,root,root)%{_mandir}/man8/kallsyms.8*
%attr(644,root,root)%{_mandir}/man5/modprobe.conf.5*
%attr(644,root,root)%{_mandir}/man5/modules.dep.5*
%attr(644,root,root)%{_mandir}/man8/depmod.8*
%attr(644,root,root)%{_mandir}/man8/insmod.8*
%attr(644,root,root)%{_mandir}/man8/lsmod.8*
%attr(644,root,root)%{_mandir}/man8/modprobe.8*
%attr(644,root,root)%{_mandir}/man8/rmmod.8*
%attr(-,root,root) %doc COPYING README CREDITS TODO ChangeLog NEWS example/kallsyms.c include/kallsyms.h

%changelog
* Sat Feb 8 2003 Rusty Russell <rusty@rustcorp.com.au>
- Fix links for kallsyms and ksyms

* Mon Dec 9 2002 Roger Luethi <rl@hellgate.ch>
- Make soft links point to insmod.old

* Tue Nov 12 2002 SL Baur  <steve@kbuxd.necst.nec.co.jp>
- update modutils for in kernel module loader

